/* File: CONV.C */

#include <stdio.h>
#include <math.h>
#include "const.h"
#include "CONV.h"
#include <values.h>
#include "x_eps.h"

int CONV_WINDOW::Go (XEvent *event)
{
   switch (event ->type) {
   case Expose:
      if (event ->xexpose .count == 0) Draw ();
      break;
   default:
      break;
   }
   return NOTHING;
}

void CONV_WINDOW::DisplayItself (void)
{
   Draw ();
}
 
CONV_WINDOW::CONV_WINDOW (Display *dsp, WINDOW *prnt, char *ClassName, 
   char *Name, int x, int y, unsigned int width, unsigned int height,
   unsigned int border_width, unsigned long border, unsigned long background,
   unsigned long foreground, Font fid) :
   WINDOW (dsp, prnt, ClassName, Name, x, y, width, height, border_width,
   border, background, True, fid, foreground)
{
   SetInput (ExposureMask);
}

void CONV_WINDOW::Draw (void)
{
   if (*fm == NULL) return;
   Clear ();
   if (n_of_points == 1 || n_of_points == 0) return;

   XWindowAttributes xwa;

   GetAttributes (&xwa);
   deltax = (double) (xwa .width - 8) / (*max_n_of_points - 1);
   x0     = 4.;
   ymin   = MAXDOUBLE;
   ymax   = (*fm) [0];
   int i;
   for (i = 0; i < n_of_points; i++) if (ymin > (*fm) [i]) ymin = (*fm) [i];
   if (fabs (ymax - ymin) < X_EPS) {
      DrawLine (4, xwa .height - 4, XVal ((double) n_of_points - 1.),
         xwa .height - 4);
      return;
   }
   deltay = - (xwa .height - 8) / (ymax - ymin);
   y0     = xwa .height - 4 - ymin * deltay;

   int x1 = XVal (0.);
   int y1 = YVal ((*fm) [0]);

   for (i = 1; i < n_of_points; i++) {
      int x2 = XVal ((double) i);
      int y2 = MAX (YVal ((*fm) [i]), y1);

      DrawLine (x1, y1, x2, y2);
      x1 = x2;
      y1 = y2;
   }
}

int CONV_WINDOW::XVal (double x)
{
   return (int) (x0 + deltax * x);
}

int CONV_WINDOW::YVal (double y)
{
   return (int) (y0 + deltay * y);
}



