/* File: CONV.h */

#ifndef __CONV_WINDOW
#define __CONV_WINDOW

#include "WINDOW.h"

#define CONV_WINDOW_NAME "CONV_WINDOW"

class CONV_WINDOW : public WINDOW {
   private: 
      double **fm;
      int n_of_points;
      int *max_n_of_points;
      double deltax, x0, deltay, y0, ymax, ymin;
      int XVal (double x);
      int YVal (double y);
      void Draw (void);
   public:
      void DisplayItself (void);
      CONV_WINDOW (Display *dsp, WINDOW *prnt, char *ClassName, char *Name,
         int x, int y, unsigned int width, unsigned int height,
         unsigned int border_width, unsigned long border,
         unsigned long background, unsigned long foreground, Font fid);
      int Go (XEvent *event);
      void SetN (int n) {n_of_points = n;};
      void SetMaxN (int *n) {max_n_of_points = n;};
      void SetFm (double **Fm) {fm = Fm;};
   };

#endif
