/* File: MENU.C */

#include "SUBMENU.h"
#include "MENU.h"
#include "MENU_ITEM.h"
#include "const.h"
#include "work.h"
#include "ERROR.h"

void MENU::S0 (FILE *in)
{
   int x = 0;

   for (;;) {
      char token [128];

      read_token (in, token);
      if (feof (in)) break;
      if (strcmp (token, "MENUITEM") == 0) {
         read_string (in, token);

         XFontStruct       *font_info = QueryFont ();
         unsigned int      width      = TEXT_WIDTH (token) + 2;
         XWindowAttributes xwa;

         GetAttributes (&xwa);

         MENU_ITEM    *menu_item = new MENU_ITEM (display, this, token, x, 0,
            width, xwa .height, NULL, read_index (in));

         if (menu_item == NULL) {
            ERROR ("no memory");
         }
         x += width;
         XFreeFontInfo (NULL, font_info, 1);
      } else if (strcmp (token, "POPUP") == 0) {
         read_string (in, token);

         XFontStruct       *font_info = QueryFont ();
         unsigned int      width      = TEXT_WIDTH (token) + 2;
         XWindowAttributes xwa;

         GetAttributes (&xwa);
      
         SUBMENU *submenu = new SUBMENU (display, parent, x,
            xwa .height + xwa .y + 1, 1, 1,
            GetForeground (), GetBackground ());

         if (submenu == NULL) {
            ERROR ("no memory");
         }

         MENU_ITEM *menu_item = new MENU_ITEM (display, this, token, x, 0,
            1, 1, submenu);

         if (menu_item == NULL) {
            ERROR ("no memory");
         }
         read_token (in, token);

         unsigned int swidth, sheight;

         submenu ->S1 (&swidth, &sheight, in);
         width  = MAX (swidth + 2, width);
         menu_item ->Resize (width, xwa .height);
         submenu ->Resize (width - 2, sheight);
         submenu ->Justify ();
         x += width;
         XFreeFontInfo (NULL, font_info, 1);
      } else
         break;
   }
}

void MENU::Load (char *name)
{
   FILE *in = fopen (name, "r");

   if (in == NULL) {
      ERROR ("MENU");
   }
   S0 (in);
   fclose (in);
}

void MENU::Resize (void)
{
   XWindowAttributes pxwa, xwa;

   parent ->GetAttributes (&pxwa);
   GetAttributes (&xwa);
   WINDOW::Resize (pxwa .width, xwa .height);
}

int MENU::Go (XEvent *event)
{
   switch (event ->type) {
   default:
      break;
   }
   return NOTHING;
}

MENU::MENU (Display *dsp, WINDOW *prnt, int x, int y, unsigned int width,
   unsigned int height, unsigned long background, unsigned long foreground,
   char *name) :
   WINDOW (dsp, prnt, MENU_NAME, NULL, x, y, width, height, 1, 
   BlackPixel (dsp, DefaultScreen (dsp)), 
   background, True, prnt ->GetFont (), foreground)
{
   SetInput (ExposureMask);
   Load (name);
}

MENU::~MENU (void)
{
   Window       *children;
   unsigned int n_children;

   GetChildren (&children, &n_children);

   for (int i = 0; i < n_children; i++) {
      struct {
         unsigned char *tc;
      } *prop;

      GetThisProperty (display, children [i], (unsigned char **) &prop);
      delete (MENU_ITEM *) prop ->tc;
      XFree ((char *) prop);
   }
   if (n_children > 0) XFree ((char *) children);

}
