/* File: OUTPUT.h */

#include "CONV.h"
#include "PROJ.h"
#include "NUM.h"

class OUTPUT {
   private:
      int         n_of_points;
      int         *max_n_of_points;
      double      **fm;
      CONV_WINDOW *window;
      double      *min_bound, *max_bound;
      int         n_of_variables;
      double      ***xn;
      PROJ_WINDOW **pwindow;
      Display     *display;
      Font        fid;
      NUM_WINDOW  *nwindow;
      WINDOW      *area;
   public:
      void Init (int n, Display *dsp, double *A, double *B, WINDOW *area,
         Font fid, int *It, double ***Xn, double **Fm);
      Bool IsNumericWindow (void);
      void CreateNumericWindow (int n);
      void DestroyNumericWindow (void);
      void Finish (void);
      friend int met_out (int n);
      void CreateConvergenceWindow (void);
      void DestroyConvergenceWindow (void);
      void SetN (int n);
      void DisplayItself (void);
      Bool IsConvergenceWindow (void);
      Bool IsProjectionWindow (int var);
      void CreateProjectionWindow (int var);
      void DestroyProjectionWindow (int var);
      void SetMinBound (double *A);
      void SetMaxBound (double *B);
   };

#ifdef __OUTPUT

OUTPUT output;

#else

extern OUTPUT output;

#endif
