/* File: PROJ.h */

#ifndef __PROJ_WINDOW
#define __PROJ_WINDOW

#include "WINDOW.h"

#define PROJ_WINDOW_NAME "PROJ_WINDOW"

class PROJ_WINDOW : public WINDOW {
   private: 
      double *min_bound, *max_bound;
      double ***xn;
      int    n_of_variables, variable;
      double **fm;
      int    n_of_points;
      int    *max_n_of_points;
      double deltax, x0, deltay, y0, ymax, ymin;
      int XVal (double x);
      int YVal (double y);
      void Draw (void);
      void DrawCross (int x, int y);
   public:
      void DisplayItself (void);
      PROJ_WINDOW (Display *dsp, WINDOW *prnt, char *ClassName, char *Name,
         int x, int y, unsigned int width, unsigned int height,
         unsigned int border_width, unsigned long border,
         unsigned long background, unsigned long foreground, Font fid);
      int Go (XEvent *event);
      void SetN (int n) {n_of_points = n;};
      void SetMaxN (int *n) {max_n_of_points = n;};
      void SetFm (double **Fm) {fm = Fm;};
      void SetXn (double ***Xn) {xn = Xn;};
      void SetNOfVariables (int n) {n_of_variables = n;};
      void SetVariable (int n) {variable = n;};
      void SetMinBound (double *a) {min_bound = a;};
      void SetMaxBound (double *a) {max_bound = a;};
   };

#endif
