/* File: SHIT.C */

#include "SHIT.h"
#include "task.h"
#include "res.h"
#include "PAR_DBOX.h"
#include "ERROR.h"

#define DBOX_BACKGROUND WhitePixel (display, DefaultScreen (display))
#define DBOX_FOREGROUND BlackPixel (display, DefaultScreen (display))

METHODSHIT::METHODSHIT (double *Start, double *Xl, double *Xu, int N)
{
   start                          = Start;
   lower_bounds                   = Xl;
   upper_bounds                   = Xu;
   number_of_variables            = N;
   number_of_iterations           = 40;
   number_of_constraints          = 0;
   number_of_equality_constraints = 0;
}

int METHODSHIT::EnterParameters (Display *display, WINDOW *wnd)
{
   VELEMENT Variable [4];

   Variable [0] .ident   = XL;
   Variable [0] .size    = number_of_variables;
   Variable [0] .pointer = (void *) lower_bounds;
   Variable [0] .format  = DOUBLE;
   Variable [1] .ident   = XU;
   Variable [1] .size    = number_of_variables;
   Variable [1] .pointer = (void *) upper_bounds;
   Variable [1] .format  = DOUBLE;
   Variable [2] .ident   = START;
   Variable [2] .size    = number_of_variables;
   Variable [2] .pointer = (void *) start;
   Variable [2] .format  = DOUBLE;
   Variable [3] .pointer = NULL;

   int VPar [3];

   VPar [0] = Variable [0] .size;
   VPar [1] = Variable [1] .size;
   VPar [2] = Variable [2] .size;

   int VID [3];

   VID [0] = Variable [0] .ident;
   VID [1] = Variable [1] .ident;
   VID [2] = Variable [2] .ident;

   FELEMENT Fixed [4];

   Fixed [0] .ident   = IT;
   Fixed [0] .pointer = (void *) &number_of_iterations;
   Fixed [0] .format  = INT;
   Fixed [1] .ident   = M;
   Fixed [1] .pointer = (void *) &number_of_constraints;
   Fixed [1] .format  = INT;
   Fixed [2] .ident   = ME;
   Fixed [2] .pointer = (void *) &number_of_equality_constraints;
   Fixed [2] .format  = INT;
   Fixed [3] .pointer = NULL;

   PAR_DBOX *dbox = new PAR_DBOX (display, wnd, DBOX_FOREGROUND,
      DBOX_BACKGROUND, "nlpp.res", Fixed, Variable, VPar, VID);

   if (dbox == NULL) {
      ERROR ("PAR_DBOX");
   }
   dbox ->Dialog ();
   delete dbox;
   return number_of_iterations;
}

void METHODSHIT::Run (double *x, int n, double *y, 
   double (*fi) (const double *x, int n), 
   void (*constr) (const double *x, int n, double *g, int m),
   double *fm, double **xn)
{
   fnlpql (x, lower_bounds, upper_bounds, n, y, fi, constr, 
      number_of_iterations, number_of_constraints, 
      number_of_equality_constraints, fm, xn);
}
