/* File: SMENU_ITEM.cc */

#include <stdio.h>
#include "SMENU_ITEM.h"
#include "SUBMENU.h"
#include "const.h"

void SUBMENU_ITEM::Draw (void)
{
   XWindowAttributes xwa;

   GetAttributes (&xwa);

   char *name = GetName ();

   DrawString (1, xwa .height - 2, name);
   XFree (name);
}

int SUBMENU_ITEM::Go (XEvent *event)
{
   switch (event ->type) {
   case Expose:
      if (event ->xexpose .count == 0) Draw ();
      break;
   case ButtonRelease:
      {
         XEvent nevent;

         nevent .type                 = ClientMessage;
         nevent .xclient .display     = display;
         nevent .xclient .window      = parent ->WindowID ();
         nevent .xclient .format      = 32;
         nevent .xclient .data .l [0] = (long) index;
         SendEvent (&nevent);
      }
      break;
   case EnterNotify:
   case LeaveNotify:
      Reverse ();
      break;
   }
   return NOTHING;
}

void SUBMENU_ITEM::Justify (void)
{
   XWindowAttributes pxwa;
   XFontStruct       *font_info = QueryFont ();

   parent ->GetAttributes (&pxwa);
   Resize (pxwa .width, CHAR_HEIGHT);
   XFreeFontInfo (NULL, font_info, 1);
}

SUBMENU_ITEM::SUBMENU_ITEM (Display *dsp, WINDOW *prnt, char *Name, int x, 
   int y, unsigned int width, unsigned int height, int Index) :
   MENU_ITEM (dsp, prnt, Name, x, y, width, height, NULL, Index)
{
   strcpy (class_name, SUBMENU_ITEM_NAME);
}
