/* File: WINDOW.h */

#ifndef __WINDOW
#define __WINDOW

#include "const.h"
#include <X11/Xutil.h>

class WINDOW {
   protected:
      char    class_name [128];
      Display *display;
      WINDOW  *parent;
      Window  window;
      GC      gc;
      Bool    visible;
      virtual int Go (XEvent *) {return NOTHING;};
   public:
      XFontStruct *QueryFont (void);
      void SendEvent (XEvent *event);
      void Lower (void);
      void Raise (void);
      void GetChildren (Window **children, unsigned int *n_children);
      friend int Dispatch (XEvent *event);
      WINDOW (Display *dsp, WINDOW *prnt, char *ClassName, char *Name, int x, 
         int y, unsigned int width, unsigned int height, 
         unsigned int border_width, unsigned long border, 
         unsigned long background, Bool vsbl, Font fid,
         unsigned long foreground);
      char *ClassName (void) {return class_name;};
      void SetVisible (Bool vsbl);
      virtual ~WINDOW (void);
      Window WindowID (void);
      void Show (Bool vsbl);
      void SetCursor (Cursor cursor);
      void RestoreCursor (void);
      void SetName (char *name);
      char *GetName (void);
      void SetNormalHints (XSizeHints *hint);
      void GetNormalHints (XSizeHints *hint);
      void SetInput (long mask);
      void SetFont (Font fid);
      Font GetFont (void);
      void SetBackground (unsigned long col);
      unsigned long GetBackground (void);
      void SetForeground (unsigned long col);
      unsigned long GetForeground (void);
      void MoveResize (int x, int y, unsigned int width, unsigned int height);
      void Resize (unsigned int width, unsigned int height);
      void Move (int x, int y);
      void DrawString (int x, int y, char *string);
      void DrawLine (int x1, int y1, int x2, int y2);
      void DrawRectangle (int x, int y, unsigned int width, 
         unsigned int height);
      void FillRectangle (int x, int y, unsigned int width, 
         unsigned int height);
      void GetAttributes (XWindowAttributes *xwa);
      void Clear (void);
   };

#endif
