/* File: FI.C */

#include "fi.h"
#include <math.h>

/* Goal function definition */

double f (const double *x, int n)
{
   int    i;
   double y = 0;

   for (i = 0; i < n; i++) {
		double z = x [i];

		y += z * z - cos (18. * z);
	}
	return 2 * y / n;
}

/*double f (const double *x, int n)
{
	double y  = 1.;
   double x1 = x [0];
   double x2 = x [1];
   double a  = 1. + x1 + x2;
   double b  = 2 * x1 - 3 * x2;
   double x3 = x1 * x1;
   double x4 = x2 * x2;

	y += a * a * (19 - 14 * x1 + 3 * x3 - 14 * x2 + 6 * x1 * x2 + 3 * x4);
	y *= 30 + b * b * (18 - 32 * x1 + 12 * x3 + 48 * x2 - 36 * x1 * x2 + 27 * x4);
	return (y);
}

double f (const double *x, int n)
{
	double y = 0;

	while (n-- > 0) {
		double lb = 0.;
		double ub = 1.;
		double a;

		random_point (&a, &lb, &ub, 1);
		y += x [n] * x [n] + 0.0001 * a;
	}
	return y;
}

double f (const double *x, int n)
{
   return (4. * x [0] - x [1] * x [1] - 12.);
}*/

/* Definition of constraints */

void constr (const double *x, int n, double *g, int ng)
{
/*
	ng > 0 - calculates all constaints
	ng < 0  - calculates only constraint with number (-ng)
*/
   double x1 = x [0];
   double x2 = x [1];
   double x3 = x1 * x1;
   double x4 = x2 * x2;

   if (ng > 0) {
		g [0] = 25. - x3 - x4;
		g [1] = 10. * x1 - x3 + 10. * x2 - x4 - 34.;
		g [2] = x1;
		g [3] = x2;
   } else {
      ng = -ng;
      switch (ng) {
      case 1:
			g [0] = 25. - x3 - x4;
			break;
      case 2:
			g [1] = 10. * x1 - x3 + 10. * x2 - x4 - 34.;
			break;
      case 3:
			g [2] = x1;
			break;
      case 4:
			g [3] = x2;
			break;
      }
   }
}
