/* File: task.h */

#define TRUE     1
#define FALSE    0
#define MAX(A,B) ((A) > (B) ? (A) : (B))
#define MIN(A,B) ((A) < (B) ? (A) : (B))
#define POW_2(X) ((X) * (X))

double ats (void);
void   copy_array (double *dest, const double *src, int n);
void   lp_point (double *x, const double *a, const double *b, int n, int nr);
void   random_point (double *x, const double *a, const double *b, int n);
double distance (const double *x1, const double *x2, int n);
double r1mach (int i);
void array_maximum (const double *x, int n, int *index);
void array_minimum (const double *x, int n, int *index);
void integer_array_fill (int *dest, int dim, int sample);
void covariation_matrix_diagonal (const double **x, const double *f, double *r,
   int n_of_points, int dim);
void sort_with_index (double *r, int *nr, int n);
void scale_to_zero_one_bounds (double *dest, const double *src,
   const double *lb, const double *ub, int dim);
void dispersion (const double *x, int n_of_points, double *mean, double *disp);
void double_array_fill (double *dest, int dim, double sample);
double norma (const double *x, int n);
double increment (double x, double a, double b, double dx);
double sign (double x, double y);
void fnlpql (double *x, const double *a, const double *b, int n, double *f, 
   double (*function) (const double *x, int n),
   void (*constraints) (const double *x, int n, double *g, int m),
   int it, int m,
   int me, double *fm, double **xn);
void lbayes (double *x, const double *a, const double *b, int n, double *y,
   double (*f) (const double *x, int n), int max_it, double aniu, double beta,
   double *pfm, double **pxn);
void mig1 (double *x, const double *a, const double *b, int n, double *y,
   double (*f) (const double *x, int n), int max_l, double *fm, double **xn);
void unt (double *x, const double *a, const double *b, int n, double *y,
   double (*f) (const double *x, int n), int MAX_l, int init_points, 
   double *fm, double **xn);
void   bayes1 (double *x, const double *a, const double *b, int n, double *y,
   double (*f) (const double *, int), int it, int lt, double *fm, double **xn);
void exkor (double *x, const double *a, const double *b, int n, double *y,
   double (*f) (const double *x, int n), int max_l, int init_points, 
   double *pfm, double **pxn);
void lpmin (double *x, const double *a, const double *b, int n, double *y,
   double (*f) (const double *x, int n), int max_l, int init_points,
   double *pfm, double **pxn);
void glopt (double *x, const double *a, const double *b, int n, double *y, 
   double (*f) (const double *x, int n), int max_it, int lt, int max_l, 
   double *pfm, double **pxn);
void flexi (double *z, int n, double *ff, 
   double (*fi) (const double *x, int n),
   void (*constr) (const double *x, int n, double *g, int m), int nfmax, 
   int nc, int nic, double size, double conver, double *pfm, double **pxn);

